
;******************************************************
.include "8515def.inc"	;  AT90S8515
.def temp=r16		; 
.def cols=r18		;  
			;
.def rots=r21		;  
.def key=r19		; 
.def scancod=r20	; 

.org $000
	rjmp init
.org $007
	rjmp scankeys	; 
 ;  
      scankeys:
	clr key
	clr scancod
	ldi cols,2
	sec
     scan: rol scancod		;  -
	out PORTD,scancod	;  
	clc
	ldi rots,4
	in temp,PIND		;  
     mm: rol temp
	brcc nn			;  
	rjmp press		;   (=0)
     nn: inc key		;  
	dec rots		;  
	brne mm
	dec cols		;  
	brne scan
     press: cpi key,8
	breq f1			;   
	rcall outkey		;  
     f1: reti

     outkey:
	cpi key,0 
	breq case1
	cpi key,1
	breq case2 
	cpi key,2
	breq case3
	cpi key,3 
	breq case4
	cpi key,4 
	breq case5
	cpi key,5
	breq case6
	cpi key,6
	breq case7 
	cpi key,7
	breq case8

	case1:
	ldi temp,0b01111111
	out PORTA,temp
	reti

	case2:
	ldi temp,0b10111111
	out PORTA,temp
	reti

	case3:
	ldi temp,0b11011111
	out PORTA,temp
	reti

	case4:
	ldi temp,0b11101111
	out PORTA,temp
	reti

	case5:
	ldi temp,0b11110111
	out PORTA,temp
	reti

	case6:
	ldi temp,0b11111011
	out PORTA,temp
	reti

	case7:
	ldi temp,0b11111101
	out PORTA,temp
	reti

	case8:
	ldi temp,0b11111110
	out PORTA,temp
	reti
	reti
;
init:
	ldi temp,low(RAMEND) ;
	out spl,temp	     ; 
	ldi temp,high(RAMEND)
	out sph,temp
      ; 
	ser temp
	out DDRA,temp	     ;   
	ldi temp,$03	     ;  PD0-PD3  ,
	out DDRD,temp
	ldi temp,$F0	     ;PD4-PD7  
	out PORTD,temp
      ;  0
	ldi temp,$05
	out TCCR0,temp	     ;  1024	
	ldi temp, (1<<TOIE0)
	out TIMSK, temp	     ;   
      
	sei		     ; 
      loop: rjmp loop

     